<?php
if (!defined('ABSPATH')) {
    exit();
}

/**
 * Hook in and register a metabox to handle a theme options page and adds a menu item.
 */
class CDBBC_option_settings{
    function __construct()
    {
     if (is_admin()) {
   
        add_action('cmb2_admin_init', array($this,'cdbbc_option_settings'));
    
     }

    }

function cdbbc_option_settings()
{

    /**
     * Registers main options page menu item and form.
     */
    $prefix = "cdbbc_";
    $args = array(
        'id' => $prefix.'general_settings_tab',
        'title' => 'Crypto Donation Box Settings',
        'object_types' => array('options-page'),
        'menu_title' => false,
        'option_key' => 'cdbbc-add-wallet',
        'parent_slug' => 'cool-crypto-plugins',
        'tab_group' => 'Wallet_Settings',
        'tab_title' => 'Add wallet/coin',
    );

    // 'tab_group' property is supported in > 2.4.0.
    if (version_compare(CMB2_VERSION, '2.4.0')) {
        $args['display_cb'] = 'cdbbc_options_display_with_tabs';
    }

    $gernal_tab = new_cmb2_box($args);

    /**
     * Options fields ids only need
     * to be unique within this box.
     * Prefix is not needed.
     */
    // Repeatable group
    $group_repeat_test = $gernal_tab->add_field(array(
        'id' => $prefix . 'group_data',
        'type' => 'group',
        'options' => array(
            'group_title' => __('Wallet', 'your-text-domain') . ' {#}', // {#} gets replaced by row number
            'add_button' => __('Add New Wallet', 'your-text-domain'),
            'remove_button' => __('Remove Wallet', 'your-text-domain'),
            'sortable' => true, // beta
            'closed' => true,
        ),
    ));

    $gernal_tab->add_group_field($group_repeat_test, array(
        'name' => false,
        'id' => 'coin_type',
        'type' => 'radio_inline',
        'options' => array(
            'popular' => __('Popular wallet/coin', 'cmb2'),
            'custom' => __('Custom wallet/coin  (<span style="color:red;">Pro version only</span>)', 'cmb2'),

        ),
        'default' => 'popular',
    ));
    $gernal_tab->add_group_field($group_repeat_test, array(
        'name' => __('Select wallet, coin or token', 'cmc2'),
        'desc' => '',
        'id' => 'coin',
        'type' => 'select',
        'attributes' => array(
            'required' => true, // Will be required only if visible.
            'data-conditional-id' => json_encode(array($group_repeat_test, 'coin_type')),
            'data-conditional-value' => 'popular',
        ),
        'desc'=>'You can use below coin id to show selected coins in your shortcode',
        'options' => CDBBC_supported_coins(),

    ));

    $gernal_tab->add_group_field($group_repeat_test, array(
        'name' => __('Enter address', 'cmc2'),
        'desc' => '',
        'id' => 'wallet_address',
        'attributes' => array(
            'required' => true, // Will be required only if visible.
            'data-conditional-id' => json_encode(array($group_repeat_test, 'coin_type')),
            'data-conditional-value' => 'popular',
        ),
        'type' => 'text',       

    ));

    $gernal_tab->add_group_field($group_repeat_test, array(
        'name' => __('Tag/Note (if any)', 'cmc2'),
        'desc' => '',
        'id' => 'tag_note',
        'attributes' => array(
            'data-conditional-id' => json_encode(array($group_repeat_test, 'coin_type')),
            'data-conditional-value' => 'popular',
        ),
        'type' => 'text',        

    ));
   
    $gernal_tab->add_group_field($group_repeat_test, array(
    'name' => false,
    'id' => 'proversion_permotion',
    'type' => 'text',
    'attributes' => array(
        'data-conditional-id' => json_encode(array($group_repeat_test, 'coin_type')),
        'data-conditional-value' => 'custom',
        'data-cdbbc-hide-input' => 'hide',

    ),
    'desc' => '<center><h2 style="color:red;"> <a href="https://coolplugins.net/product/cryptocurrency-donation-box-pro/" target="_blank">Buy pro </a> version to activate below feature</h2></center><img src="' . CDBBC_URL . 'assets/images/pro.png" style="width:100%">',
));



    /**
     * Registers secondary options page, and set main item as parent.
     */
    $args = array(
        'id' => $prefix.'extra_settings_tab',
        'title' => 'Crypto Donation Box Settings',
        'menu_title' => null, // Use menu title, & not title to hide main h2.
        'object_types' => array('options-page'),

        'option_key' => 'cdbbc-coin-settings',
        'parent_slug' => 'cool-crypto-plugins',
        'tab_group' => 'Wallet_Settings',
        'tab_title' => 'Settings',
    );

    // 'tab_group' property is supported in > 2.4.0.
    if (version_compare(CMB2_VERSION, '2.4.0')) {
        $args['display_cb'] = 'cdbbc_options_display_with_tabs';
    }

    $extra_tab = new_cmb2_box($args);

    $extra_tab->add_field(array(
        'name' => __('MetaMask wallet settings', 'cmc2'),
        'id' => 'metamask_settings_start',
        'type' => 'title',
      
    ));
    $extra_tab->add_field(array(
        'name' => __('Default Amount', 'cmc2'),
        'desc' => '',
        'id' => 'metamask_amount',
        'type' => 'text',
        'default' => '0.005',
        'desc' => 'Enter amount in Ethereum',
    ));
    $extra_tab->add_field(array(
        'name' => __('MetaMask Title', 'cmc2'),
        'desc' => '',
        'id' => 'metamask_title',
        'type' => 'text',
        'default' => 'Donate With MetaMask',
    ));

    $extra_tab->add_field(array(
        'name' => 'MetaMask Description',
        'id' => 'metamask_desc',
        'type' => 'textarea_small',
        'default' => 'Donate ETH Via PAY With Meta Mask',
        'desc' => '<span style="color:red">MetaMask Wallet will only support Ethereum(ETH) Donation in free version</span>
        <br><a href="https://coolplugins.net/product/cryptocurrency-donation-box-pro/" target="_blank">Buy pro </a>version to accept donation using MetaMask  in<strong> USDT(ERC20),BUSD(BEP20),BNB(BEP20),BUSD(ERC20),etc..</strong>',

    ));
    
    $extra_tab->add_field(array(
        'name' => __('Donation Box Content Settings', 'cmc2'),
        'id' => 'donation_settings_start',
        'type' => 'title',
      
    ));
    $extra_tab->add_field(array(
        'name' => __('Main Title', 'cmc2'),
        'desc' => '',
        'id' => 'main_title',
        'type' => 'text',
        'default' => 'Donate [coin-name] to this address',
    ));

    $extra_tab->add_field(array(
        'name' => 'Description',
        'id' => 'main_desc',
        'type' => 'textarea_small',
        'default' => 'Scan the QR code or copy the address below into your wallet to send some [coin-name]',
    ));
       $extra_tab->add_field(array(
        'name' => __('Donation Box Style Settings', 'cmc2'),
        'id' => 'donation_settings_style',
        'type' => 'title',
      
    ));
    $extra_tab->add_field( array(
    'name'    => 'Title Color',
    'id'      => 'main_title_color',
    'type'    => 'colorpicker',
    'default' => '#000',
    // 'options' => array(
    //     'alpha' => true, // Make this a rgba color picker.
    // ),
    ) );
     $extra_tab->add_field( array(
    'name'    => 'Content Color',
    'id'      => 'main_content_color',
    'type'    => 'colorpicker',
    'default' => '#000',
    // 'options' => array(
    //     'alpha' => true, // Make this a rgba color picker.
    // ),
    ) );
    $extra_tab->add_field( array(
    'name'    => 'Background  Color',
    'id'      => 'main_bg_color',
    'type'    => 'colorpicker',
    'default' => '#ffffff',
    // 'options' => array(
    //     'alpha' => true, // Make this a rgba color picker.
    // ),
    ) );

    $extra_tab->add_field(array(
        'name' => __('Donation Box Shortcode Settings', 'cmc2'),
        'id' => 'tab_shortcode',
        'type' => 'title',
        'desc' => '<br><br><strong>METAMASK SHORTCODE </strong><code>[crypto-donation-box type="metamask" ]</code>
        <br><br><strong>TABULAR SHORTCODE </strong><code>[crypto-donation-box type="tabular" show-coin="all"]</code>
        <br><br><strong>POPUP SHORTCODE </strong><code>[crypto-donation-box type="popup" show-coin="all"]</code>
        <br><br><strong>LIST SHORTCODE </strong><code>[crypto-donation-box type="list" show-coin="all"]</code>
        <br><br><strong>SUPPORTED ATTRIBUTE </strong>You can show selected coin by definig attributes like: <strong>show-coin="bitcoin,ethereum" </strong>
        ',
    ));
  


}

}

new CDBBC_option_settings();