<?php
if (!defined('ABSPATH')) {
    exit();
}

if (!class_exists('CDBBC_shortcode')) {
    class CDBBC_shortcode
    {
        /**
         * Constructor.
         *
         * @access private
         */
        public function __construct()
        {
            add_shortcode('crypto-donation-box', array($this, 'crypto_donation_box_shortcode'));

        }

        /*
        donation box shortcode
         */

        public function crypto_donation_box_shortcode($atts)
        {
            $attr = shortcode_atts(
                array(
                    'id' => 'something',
                    'class' => 'something else',
                    'type' => '',
                    'show-coin' => 'all',
                ),
                $atts
            );

            $output = '';
            $coin_tabs = '';
            $coin_links = '';
            $list_view = '';
            $classic_list = '';
            $tagvl = __('_tag', 'CDBBC');
            $i = 0;
            $active_tab = '';
            $design_type = $attr['type'];
            $show_coin = $attr['show-coin'];
            $selected_coin = "";

            $selected_coin = explode(",", $show_coin);

            $wallet_data = cdbbc_get_gen_option('cdbbc_group_data');

           // $cdb_meta_button = CDBBC_URL . 'assets/images/5_pay_mm_over.img';
            wp_enqueue_style('cdbbc-styles', CDBBC_URL . 'assets/css/cdbbc-styles.css',null, CDBBC_VERSION);
            wp_enqueue_script('cdbbc-copy-clipboard', CDBBC_URL . 'assets/js/clipboard.js', array('jquery'),CDBBC_VERSION, true);
            wp_enqueue_script('cdbbc-metamask-script', CDBBC_URL . 'assets/js/cdbbc-metamask.js', array('jquery'),CDBBC_VERSION, true);
            wp_enqueue_script('cdbbc-ether', CDBBC_URL . 'assets/js/ethers-5.2.umd.min.js', array('jquery'),CDBBC_VERSION, true);
            wp_enqueue_script('cdbbc-sweetalert2', CDBBC_URL . 'assets/js/sweetalert2.js', array('jquery'),CDBBC_VERSION, true);
            $main_title = cdbbc_get_extra_option('main_title');
            $metamask_title = cdbbc_get_extra_option('metamask_title');
            $metamask_desc = cdbbc_get_extra_option('metamask_desc');
            $metamask_tag = "";
            $metamask_description = !empty($metamask_desc) ? $metamask_desc : 'Donate ETH Via PAY With Metamask';
            $cdb_metamask_title = !empty($metamask_title) ? $metamask_title : 'Donate With MetaMask';
            $desc = cdbbc_get_extra_option('main_desc');
            $metamask_amount = cdbbc_get_extra_option('metamask_amount');
            $title = !empty($main_title) ? $main_title : 'Donate [coin-name] to this address';
            $description = !empty($desc) ? $desc : 'Scan the QR code or copy the address below into your wallet to send some [coin-name]';
			$title_color=cdbbc_get_extra_option('main_title_color');
            $content_color=cdbbc_get_extra_option('main_content_color');
			$bg_color=cdbbc_get_extra_option('main_bg_color');
            
            if ($show_coin == "all") {
                $all_coin_wall_add = $wallet_data;
            } else {
                $custom_array = [];
                if (is_array($wallet_data)) {
                    foreach ($wallet_data as $key => $value) {
                        if ($value['coin_type'] == "popular") {
                            if (in_array($value['coin'], $selected_coin)) {
                                $custom_array[] = $value;
                            }
                        } 
                      /*   else {
                            if (in_array($value['coin_id'], $selected_coin)) {
                                $custom_array[] = $value;
                            }

                        } */
                    }
                }
                $all_coin_wall_add = $custom_array;

            }
            
            $metamask_wall_add =  '';
            $random_num=rand(1,1000);
           $output.= '<!---------- Crypto Donation Box Version:-'. CDBBC_VERSION  .' By Cool Plugins Team-------------->';
            if ($design_type != 'metamask') {
                if (!empty($all_coin_wall_add) && is_array($all_coin_wall_add) && array_filter($all_coin_wall_add)) {
                    foreach ($all_coin_wall_add as $index => $value) {
                        $address = isset($value['wallet_address']) ? $value['wallet_address'] : "";
                        
                        if ($value['coin_type'] == "custom" || empty($address) ) {
                            continue;
                         }
                        
                     
                            $id = isset($value['coin']) ? $value['coin'] : "";
                            
                            $tag_data = isset($value['tag_note']) ? $value['tag_note'] : "";
                            $coin_logo = CDBBC_URL . 'assets/logos/' . $id . '.svg';
                         
                            if ($id != 'metamask') {
                                $coin_name = ucfirst(str_replace('-', ' ', $id));
                            } else {
                                $metamask_wall_add = isset($value['wallet_address']) ? $value['wallet_address'] : "";
                                $metamask_tag = isset($value['tag_note']) ? $value['tag_note'] : "";
                                $coin_name = 'MetaMask';
                            }
                            
                        if ($i == 0) {
                            $active_tab = 'current';
                        } else {
                            $active_tab = '';
                        }
                        $coin_random=rand(1,10000);
                        $title_content = str_replace('[coin-name]', $coin_name, $title);
                        $desc_content = str_replace('[coin-name]', $coin_name, $description);

                        $logo_html = '<img src="' . esc_url($coin_logo) . '"> ';
                        $logo_html .= esc_html($coin_name);
                        $coin_links .= '<li class="cdbbc-coins ' . esc_attr($active_tab) . '" id="' . esc_attr($id). '" data-tab="' . esc_attr($id) .$random_num .$coin_random. '-tab" data-random="'.$random_num.'">' . $logo_html . '</li>';

                        if ($design_type == 'popup') {
                            if (($id != 'metamask')) {
                                $list_view .= '<li class="cdbbc-list-items"><a class="cdbbc-list-popup" href="#donate' . esc_attr($id) .$coin_random. '" rel="modal:open"><div class="cdb-list-img"><img src="' . esc_url($coin_logo) . '"></div><div class="cdb-list-content"><span class="cdb-list-donate-txt">' . __('Donate with', 'CDBBC') . '</span><span class="cdb-list-coin">' . esc_html($coin_name) . '</span></div></a></li>';
                                $list_view .= '
                                <div id="donate' . esc_attr($id) .$coin_random. '" class="modal cdbbc_wrap_popup">
                                <div class="cdbbc-main-title">
                                <h2 class="cdbbc-title">' . wp_kses_post($title_content) . '</h2>
                                </div>
                                <div class="cdbbc-modal-body">
                                <div class="cdbbc-address">
                                <input type="text" class="wallet-address-input"  id="' . esc_attr($id) . '-list-wallet-address'.$random_num.'" name="' . esc_attr($id) . '-list-wallet-address" value="' . $address . '" readonly>';
                                $list_view .= '
                                <button class="CDBBC_btn" data-clipboard-target="#' . esc_attr($id) . '-list-wallet-address'.$random_num.'">
                                ' . __('COPY', 'CDBBC') . '</button>

                                </div>
								<div class="cdbbc_qr_code">
								<img src="https://chart.googleapis.com/chart?cht=qr&chl=' . $address . '&chs=260x260&chld=L|0" alt="Scan to Donate ' . $coin_name . ' to ' . $address . '"/>
								</div>';
                                if (isset($tag_data) && !empty($tag_data)) {
                                    $list_view .= '<div class="cdbbc_tag"><span class="cdbbc_tag_heading">' . __('Tag/Note:-', 'CDBBC') . ' </span><span class="cdbbc_tag_desc">' . wp_kses_post($tag_data) . '</span></div>';
                                }
                                $list_view .=
                                    '</div>
                                </div>';
                            } else {
                                $list_view .= '<li class="cdbbc-list-items"><a class="cdbbc-list-popup" href="#donate' . esc_attr($id) . '" rel="modal:open">
								<div class="cdb-list-img"><img src="' . esc_url($coin_logo) . '"></div><div class="cdb-list-content"><span class="cdb-list-donate-txt">' . __('Donate with', 'CDBBC') . '</span><span class="cdb-list-coin">MetaMask</span></div></a></li>';
                                $list_view .= '
                                <div id="donate' . esc_attr($id) . '" class="modal cdbbc_wrap_popup">';
                                $list_view .= '<div class="cdb-metamask-wrapper" >
                                <h2 class="CDBBC-title">' . wp_kses_post($cdb_metamask_title) . '</h2>';
                                $list_view .= '<div id="tip-button" class="tip-button" data-metamask-address="' . esc_attr($metamask_wall_add) . '" data-metamask-amount="' . esc_attr($metamask_amount) . '"></div>';
                                if (isset($tag_data) && !empty($tag_data)) {
                                    $list_view .= '<div class="cdbbc_tag"><span class="cdbbc_tag_heading">' . __('Tag/Note:-', 'CDBBC') . ' </span><span class="cdbbc_tag_desc">' . wp_kses_post($tag_data) . '</span></div>';
                                }
                                $list_view .= ' <div class="message"></div></div></div>';

                            }
                        } elseif ($design_type == 'list') {
                            if ($id != 'metamask') {
                                $classic_list .= '<li class="cdbbc-classic-list">';
                                $classic_list .= '<h2 class="CDBBC-title">' . wp_kses_post($title_content) . '</h2>';
                                $classic_list .= '<div class="CDBBC_qr_code"><img src="https://chart.googleapis.com/chart?cht=qr&chl=' . $address . '&chs=260x260&chld=L|0" alt="Scan to Donate ' . $coin_name . ' to ' . $address . '"/>';
                                $classic_list .= '</div><div class="CDBBC_classic_input_add">
                                <input type="text" class="wallet-address-input"  id="' . esc_attr($id) . '-classic-wallet-address'.$random_num.'" name="' . esc_attr($id) . '-classic-wallet-address" value="' . esc_attr($address) . '" readonly>';
                                $classic_list .= '<button class="CDBBC_btn" data-clipboard-target="#' . esc_attr($id) . '-classic-wallet-address'.$random_num.'">
                                ' . esc_html__('COPY', 'CDBBC') . '</button>
                                  </div>';

                                if (isset($tag_data) && !empty($tag_data)) {
                                    $classic_list .= '<div class="cdbbc_tag"><span class="cdbbc_tag_heading">' . esc_html__('Tag/Note:-', 'CDBBC') . ' </span><span class="cdbbc_tag_desc">' . wp_kses_post($tag_data) . '</span></div>';
                                }
                                $classic_list .= '</li>';
                            } else {
                                $classic_list .= '<li class="cdbbc-classic-list">
                                <h2 class="CDBBC-title">' . wp_kses_post($cdb_metamask_title) . '</h2>';
                                $classic_list .= '<div class="tip-button" data-metamask-address="' . esc_attr($metamask_wall_add) . '" data-metamask-amount="' . esc_attr($metamask_amount) . '"></div>';
                                if (isset($tag_data) && !empty($tag_data)) {
                                    $classic_list .= '<div class="cdbbc_tag"><span class="cdbbc_tag_heading">' . esc_html__('Tag/Note:-', 'CDBBC') . ' </span><span class="cdbbc_tag_desc">' . wp_kses_post($tag_data) . '</span></div>';
                                }
                                $classic_list .= '<div class="message"></div></li>';
                            }
                        } else {
							
                            $coin_tabs .= '<div class="dbd-tabs-content ' . esc_attr($active_tab) . '" id="' . esc_attr($id) .$random_num.$coin_random. '-tab" style="background:'.$bg_color.';">';

                            if ($id != 'metamask') {
                                $coin_tabs .= '<div class="CDBBC_qr_code"><img src="https://chart.googleapis.com/chart?cht=qr&chl=' . $address . '&chs=260x260&chld=L|0" alt="Scan to Donate ' . $coin_name . ' to ' . $address . '"/>';
                                $coin_tabs .= '</div><div class="CDBBC_input_add">
                                <h2 class="CDBBC-title" style="color:'.$title_color.'">' . wp_kses_post($title_content) . '</h2>
                                <p class="CDBBC-desc">' . wp_kses_post($desc_content) . '</p>';
                                if (isset($tag_data) && !empty($tag_data)) {
                                    $coin_tabs .= '<div class="cdbbc_tag"><span class="cdbbc_tag_heading">' . __('Tag/Note:-', 'CDBBC') . ' </span><span class="cdbbc_tag_desc">' . wp_kses_post($tag_data) . '</span></div>';
                                }
                                $coin_tabs .= ' <input type="text" class="wallet-address-input"  id="' . esc_attr($id) . '-wallet-address'.$random_num.'" name="' . esc_attr($id) . '-wallet-address" value="' . esc_attr($address) . '" readonly>';

                                $coin_tabs .= '
                                <button class="CDBBC_btn" data-clipboard-target="#' . esc_attr($id) . '-wallet-address'.$random_num.'">
                                ' . __('COPY', 'CDBBC') . '</button></div>';
                            } else {

                                $coin_tabs .= '<div class="cdb-metamask-wrapper" >
                                <h2 class="CDBBC-title" style="color:'.$title_color.'">' . wp_kses_post($cdb_metamask_title) . '</h2>
                                <p class="CDBBC-desc">' . wp_kses_post($metamask_description) . '</p>';
                                $coin_tabs .= '<div class="tip-button" data-metamask-address="' . esc_attr($metamask_wall_add) . '" data-metamask-amount="' . esc_attr($metamask_amount) . '"></div>';
                                if (isset($tag_data) && !empty($tag_data)) {
                                    $coin_tabs .= '<div class="cdbbc_tag"><span class="cdbbc_tag_heading">' . __('Tag/Note:-', 'CDBBC') . ' </span><span class="cdbbc_tag_desc">' . wp_kses_post($tag_data) . '</span></div>';
                                }
                                $coin_tabs .= '<div class="message"></div></div>';
                            }
                            $coin_tabs .= '</div>';
                        }

                        $i++;

                    }

                    if ($design_type == 'popup') {
                        wp_enqueue_style('cdbbc-jquery-modal', CDBBC_URL . 'assets/css/jquery.modal.min.css');
                        wp_enqueue_script('cdbbc-jquery-modal-js', CDBBC_URL . 'assets/js/jquery.modal.min.js', array('jquery'), true);
                        $output .= '<div class="cdbbc-list-container">
                    <div class="cdbbc-list-title"><h3>Donate</h3>
                    </div>
                    <div class="cdbbc-list-view">
                      <ul>';
                        $output .= $list_view;
                        $output .= '
                      </ul>
                    </div>
                    </div>';

                    } elseif ($design_type == 'list') {
                        $output .= '<div class="cdbbc-classic-container">';
                        $output .= '<ul class="cdbbc-classic-list">';
                        $output .= $classic_list;
                        $output .= '</ul></div>';

                    } else {
                        $output .= '<div class="cdbbc-container" ><div class="cdbbc-tab-rand'.$random_num.'">';
                        $output .= '<ul class="cdbbc-tabs" id="cdbbc-coin-list">' . $coin_links . '</ul>';
                        $output .= $coin_tabs;
						

                        $output .= '</div></div>';

                    }
                } else {
                    $output .= '<h6>' . __('Please Add coin wallet address in plugin settings panel', 'CDBBC') . '</h6>';
                }
            } else {
                if (!empty($all_coin_wall_add) && is_array($all_coin_wall_add) && array_filter($all_coin_wall_add)) {
                foreach ($all_coin_wall_add as $index => $value) {
                      $id = isset($value['coin']) ? $value['coin'] : "";
                        if ($id == 'metamask') {
                            $metamask_wall_add = isset($value['wallet_address']) ? $value['wallet_address'] : "";
                            $metamask_tag = isset($value['tag_note']) ? $value['tag_note'] : "";
                        } 
                }
            }
                if ($metamask_wall_add != '') {
                    $output .= '<div class="cdb-metamask-wrapper" >
                  <h2 class="CDBBC-title">' . wp_kses_post($cdb_metamask_title) . '</h2>
                    <p class="CDBBC-desc">' . wp_kses_post($metamask_description) . '</p>';
                    $output .= '<div class="tip-button" data-metamask-address="' . esc_attr($metamask_wall_add) . '" data-metamask-amount="' . esc_attr($metamask_amount) . '"></div>';

                    if (isset($metamask_tag) && !empty($metamask_tag)) {
                        $output .= '<div class="cdbbc_tag"><span class="cdbbc_tag_heading">' . esc_html__('Tag/Note:-', 'CDBBC') . ' </span><span class="cdbbc_tag_desc">' . wp_kses_post($metamask_tag) . '</span></div>';
                    }
                    $output .= '<div class="message"></div></div>';
                } else {
                    $output .= '<h6>' . esc_html__('Please Add ETH address for MetaMask in plugin settings panel', 'CDBBC') . '</h6>';
                }
            }
			$dynamic_style= '
							ul.cdbbc-tabs li.cdbbc-coins.current,
                            .cdbbc-list-container .cdbbc-list-view li.cdbbc-list-items,
                            .cdb-metamask-wrapper,
                            .modal.cdbbc_wrap_popup,.cdbbc-classic-container li.cdbbc-classic-list{
								background:' . $bg_color . ';
								
							}
                            .cdbbc-classic-list h2.CDBBC-title,
                            .cdbbc-main-title h2.cdbbc-title,
                            .cdb-metamask-wrapper h2.CDBBC-title,
                            .CDBBC_input_add .cdbbc_tag span.cdbbc_tag_heading,
                            .cdbbc-classic-list .cdbbc_tag span.cdbbc_tag_heading,
                            .cdbbc-list-popup span.cdb-list-coin,
                            .cdb-metamask-wrapper .cdbbc_tag span.cdbbc_tag_heading,
                            .cdbbc-container ul.cdbbc-tabs li.current,
                             .cdbbc-modal-body .cdbbc_tag span.cdbbc_tag_heading
                            {
                             color:' . $title_color . ';
                            }
                            .CDBBC_input_add p.CDBBC-desc,
                            .cdb-metamask-wrapper p.CDBBC-desc,
                            .cdbbc-list-popup span.cdb-list-donate-txt,
                            .CDBBC_input_add .cdbbc_tag span.cdbbc_tag_desc,
                             .cdbbc-classic-list .cdbbc_tag span.cdbbc_tag_desc,
                             .cdb-metamask-wrapper .cdbbc_tag span.cdbbc_tag_desc,
                             .cdbbc-modal-body .cdbbc_tag span.cdbbc_tag_desc
                            {
                                color:' . $content_color . ';
                            }
							';
            wp_add_inline_style('cdbbc-styles', $dynamic_style);

            return $output;
        }
    }

}
new CDBBC_shortcode();
